From 4c79f89d71c1193e4f0b1329c08877db04009f56 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 30 2016 19:07:11 +0000
Subject: [PATCH 377/1001] Another handy health check script.


---

diff --git a/check-cache-coverage.py b/check-cache-coverage.py
new file mode 100755
index 0000000..8aad708
--- /dev/null
+++ b/check-cache-coverage.py
@@ -0,0 +1,43 @@
+#!/usr/bin/env python
+""" cache coverage checker.
+
+Runs through all possible cache keys and checks if there is a corresponding
+value already cached for it.
+
+Useful as a sanity check during development.
+
+Could make a good nagios check one day.  If the cache coverage is below 50%,
+then the site will be very slow.  We should run some sort of script that
+forcibly re-warms the cache.
+
+Authors:    Ralph Bean <rbean@redhat.com>
+"""
+
+import sys
+import dogpile.cache
+
+import hubs.widgets.base
+import hubs.models
+
+import fedmsg.config
+
+config = fedmsg.config.load_config()
+
+empty, full = 0, 0
+session = hubs.models.init(config['hubs.sqlalchemy.uri'])
+for widget in session.query(hubs.models.Widget).all():
+    key = hubs.widgets.base.cache_key_generator(widget, **widget.config)
+    result = hubs.widgets.base.cache.get(key, ignore_expiration=True)
+    if isinstance(result, dogpile.cache.api.NoValue):
+        empty += 1
+    else:
+        full += 1
+    sys.stdout.write('.')
+    sys.stdout.flush()
+sys.stdout.write('\n')
+sys.stdout.flush()
+
+total = empty + full
+print full, "cache values found. ", empty, "are missing."
+print full / float(total) * 100, "percent cache coverage."
+
diff --git a/check-queue-length.py b/check-queue-length.py
new file mode 100755
index 0000000..7121257
--- /dev/null
+++ b/check-queue-length.py
@@ -0,0 +1,23 @@
+#!/usr/bin/env python
+""" redis queue length checker.
+
+Simply prints out the length of the redis queue for our cache workers.
+
+Useful as a sanity check during development.
+
+Could make a good nagios check one day.  If the queue is going up and up, we
+should alert nagios.  We just need to spin up more cache workers.
+
+We could also graph this in collectd, for fun and profit.
+
+Authors:    Ralph Bean <rbean@redhat.com>
+"""
+
+import fedmsg.config
+config = fedmsg.config.load_config()
+
+import retask
+queue = retask.queue.Queue(config['hubs.redis.work-queue-name'])
+queue.connect()
+
+print 'Cache worker queue length is', queue.length

